#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>


#define N 3
#define TAILLE N*N


typedef int tGrille[TAILLE][TAILLE];


void chargerGrille(tGrille g){
   char nomFichier[30];
   FILE * f;

   printf("Nom du fichier ? ");
   scanf("%s", nomFichier);
   f = fopen(nomFichier, "rb");

   while (f==NULL){
       printf("\n ERREUR sur le fichier %s\n", nomFichier);
       printf("Nom du fichier ?\n");
       scanf("%s", nomFichier);
       f = fopen(nomFichier, "rb");
   }

   fread(g, sizeof(int), TAILLE*TAILLE, f);
   fclose(f);
}

void afficherGrille(tGrille grille){
    int lignes, colonnes = 0;
    printf("     1  2  3   4  5  6   7  8  9  \n   +---------+---------+---------+\n");  
    for (lignes = 0; lignes < TAILLE ; lignes++){ // Parcours des lignes de la grille
        printf("%d  | ", lignes+1); // affichage du numero de ligne a gauche de la grille
        for (colonnes = 0 ; colonnes < TAILLE ; colonnes++){ // Parcours des colonnes de la grille
            if((colonnes+1)%3 == 0){ // si la colonne est 3,6 ou 9 (divisible par 3)
                if(colonnes+1 == 3 || colonnes+1 == 6){ // si la colonne est 3 ou 6
                    if(grille[lignes][colonnes] == 0){ 
                        printf(". | ");
                    }else { 
                        printf("%d | ", grille[lignes][colonnes]);
                    }
                }else { // si la colonne est 9
                    if(grille[lignes][colonnes] == 0){
                        printf(". |\n");
                    }else{
                        printf("%d |\n", grille[lignes][colonnes]);
                    }
                }
            }else {
                if(grille[lignes][colonnes] == 0){ 
                    printf(".  ");
                }else {
                    printf("%d  ", grille[lignes][colonnes]);
                }
            }
   
       }
       if((lignes+1)%3 == 0){ // toutes les 3 lignes, on envoie la ligne qui montre la separation des blocs
            printf("   +---------+---------+---------+\n");
        }
        
   } 
}

void saisir(int *entree){
    char saisie[2];
    int valeur;
    
    scanf("%s", saisie);
    while(sscanf(saisie, "%d", &valeur) == 0 || valeur > TAILLE || valeur <= 0 ){
        printf("\nLa valeur saisie est incorrecte, veuillez réessayer avec un entier compris entre 1 et 9 : ");
        scanf("%s", saisie);
    }
    *entree = valeur;
}

bool possible(tGrille grille, int nLigne, int nColonne, int val){
    bool estPossible = true;
    bool estPossibleLigne = true;
    bool estPossibleColonne = true;
    int lignes, colonnes, ligneDuBloc, colonneDuBloc = 0;

    for (lignes = 0; lignes < TAILLE ; lignes++){ 
        for (colonnes = 0 ; colonnes < TAILLE ; colonnes++){ // double boucle, parcours valeur par valeur
            if(lignes == nLigne && grille[lignes][colonnes] == val){ // si la valeur est deja presente dans la ligne
                estPossible = false;
                estPossibleLigne = false;    
                printf("\nErreur : la valeur est déjà présente dans la ligne choisie\n");
            }
            if(colonnes == nColonne && grille[lignes][colonnes] == val){ // si la valeur est deja presente dans la colonne
                estPossible = false;
                estPossibleColonne = false;
                printf("\nErreur : la valeur est déjà présente dans la colonne choisie\n");
            }
        }
    }
    
    
    int bloc[2]; // initialisation d'un tableau bloc

    // on divise la ligne choisie par le nombre de blocs par ligne pour trouver dans quel bloc on se trouve
    bloc[0] = nLigne/N; 
    // on divise la colonne choisie par le nombre de blocs par colonne pour trouver dans quel bloc on se trouve
    bloc[1] = nColonne/N;

    bool est_possible_bloc = true;

    if (estPossibleLigne && estPossibleColonne){
        // parcours a l'interieur du bloc, on retrouve de depart et de fin dans la ligne, dans le bloc
        for(int ligneDuBloc = ((bloc[0]*N)-(N-1)); ligneDuBloc <= bloc[0]*N; ligneDuBloc++){
            // idem pour la colonne
            for(int colonneDuBloc = ((bloc[1]*N)-(N-1)); colonneDuBloc <= bloc[1]*N; colonneDuBloc++){
                if(ligneDuBloc != lignes && colonneDuBloc != colonnes){
                    if(grille[ligneDuBloc][colonneDuBloc] == val){
                        estPossible = false;
                        est_possible_bloc = false;
                    }
                }
            }
        }
        if (est_possible_bloc == false){
            printf("\nErreur : la valeur est déjà présente dans le bloc choisi\n");
        }      
    }
    return(estPossible);
}

bool grillePleine(tGrille grille){
    int lignes, colonnes = 0;
    bool estPleine = true;
    for (lignes = 0; lignes < TAILLE ; lignes++){
        for (colonnes = 0 ; colonnes < TAILLE ; colonnes++){
            if(grille[lignes][colonnes] == 0){ // si on trouve une valeur vide en parcourant la grille
                estPleine = false;
            }
        }
    }
    return(estPleine);
}

int main(){
    tGrille grille1;
    int lignes;
    int colonnes;
    int valeur;

    chargerGrille(grille1);
    
    // verification que la grille n'est pas pleine grace a une fonction qui renvoie un booleen
    while(grillePleine(grille1) == false){ 
        afficherGrille(grille1);
       
        printf("Indices de la case ?");
        saisir(&lignes);
        saisir(&colonnes);
        if(grille1[lignes-1][colonnes-1] != 0){
            printf("IMPOSSIBLE, la case n'est pas libre.\n");
        }
        else{
            printf("Valeur à insérer ?");
            saisir(&valeur);
            if(possible(grille1, lignes-1, colonnes-1, valeur)){
                grille1[lignes-1][colonnes-1] = valeur;
            }
        }
    }
    
    printf("Grille pleine, fin de partie");
}